unit puissance;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons ;

type
  TForm1 = class(TForm)
    img_plateau: TImage;
    P_plateau: TPanel;
    lbl_joueur: TLabel;
    lbl_jetons_rouge: TLabel;
    lbl_jetons_vert: TLabel;
    P_expo: TPanel;
    Label6: TLabel;
    Signature: TLabel;
    lbl_gagnant: TLabel;
    btn_newParti: TSpeedButton;
    lbl_message: TLabel;
    btn_enregistrer: TSpeedButton;
    btn_charger: TSpeedButton;
    lbl_score_rouge: TLabel;
    lbl_score_vert: TLabel;
    Timer1: TTimer;
    lbl_tps_rouge: TLabel;
    lbl_tps_vert: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    btn_cachecache: TSpeedButton;
    Edt_jRouge: TEdit;
    Edt_jVert: TEdit;
    lbl_directive: TLabel;
    n1: TLabel;
    n2: TLabel;
    n3: TLabel;
    n4: TLabel;
    n5: TLabel;
    n6: TLabel;
    n7: TLabel;
    lbl_tips: TLabel;
    Check_titre: TCheckBox;
    check_pion: TCheckBox;
    btn_reinitialisation: TButton;
    procedure img_plateauClick(Sender: TObject) ;
    function creer_pion (couleur : string ; x : integer) : integer ;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure img_plateauMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    function verif : string ;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_newPartiClick(Sender: TObject);
    procedure btn_enregistrerClick(Sender: TObject);
    procedure btn_chargerClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btn_cachecacheClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Check_titreClick(Sender: TObject);
    procedure check_pionClick(Sender: TObject);
    procedure btn_reinitialisationClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
const const_pionx=67  ; //pixels a enlever pour le placement des pions
      const_piony=79  ; //pour qu'il tombe en face des autres trous (au cause de la largeur de l'image)
var
  Form1: TForm1;
  plateau : array [1..7,1..6] of string ;
  jrouge, can_play,rgagne, vgagne,cachecache, anime_pion : boolean ;
  jetons_rouge, jetons_vert, score_rouge, score_vert : integer ;
  pion_expo : timage ;
  liste_pion : tlist ;
  tps_rouge, tps_vert : integer  ;
  titre : tthread ;

implementation
uses Thread_Titre ;

{$R *.dfm}
{$R puissance_res.res}

function tform1.creer_pion(couleur : string ; x : integer) : integer;
//retour possible de la fonction :   0-->pion cr
//                                   1-->plus de pion
//                                   2-->impossible de placer le pion (pion non cr)
var pion : timage ;
    y,j,i : integer ;
begin
if ((uppercase(couleur)='ROUGE') and (jetons_rouge>0)) or ((uppercase(couleur)='VERT') and (jetons_vert>0)) then
   begin
    result:=0 ;
    y:=6 ;
    pion:=timage.Create(self);
    pion.Parent:=P_plateau ;
    pion.OnMouseMove:=img_plateau.OnMouseMove ;
    pion.OnClick:=img_plateau.OnClick ;
    liste_pion.Add(pion) ;
    if uppercase(couleur)='ROUGE' then
       begin
       pion.Picture.Bitmap.LoadFromResourceName(hinstance,'ROUGE') ;
       jetons_rouge:=jetons_rouge-1 ;
       lbl_jetons_rouge.Caption:=inttostr(jetons_rouge) ;
       end
    else
        begin
        pion.Picture.Bitmap.LoadFromResourceName(hinstance,'VERT');
        jetons_vert:=jetons_vert-1 ;
        lbl_jetons_vert.Caption:=inttostr(jetons_vert) ;
        end;
    for j:=1 to 6 do
        begin
        if plateau[x,j]<>'0' then
           begin
           y:=j-1;
           if y<1 then
              begin
              pion:=liste_pion.Items[liste_pion.Count-1] ;
              liste_pion.Delete(liste_pion.Count-1) ;
              pion.Free ;
              if uppercase(couleur)='ROUGE' then
                 begin
                 jetons_rouge:=jetons_rouge+1 ;
                 lbl_jetons_rouge.Caption:=inttostr(jetons_rouge) ;
                 end
              else
                  begin
                  jetons_vert:=jetons_vert+1 ;
                  lbl_jetons_vert.Caption:=inttostr(jetons_vert) ;
                  end;
              result:=2 ;
              exit ;
              end;
           break ;
           end;
        end;
    if uppercase(couleur)='ROUGE' then plateau[x,y]:='1'
    else plateau[x,y]:='2' ;
    pion.Show ;
    x:=x*75-75 ;
    y:=y*75-75 ;
    pion.Left:=x ;
    can_play:=false ;
    if anime_pion then
       begin
       for i:=0 to (y div 75) do
           begin
           pion.Top:=i*75 ;
           application.ProcessMessages ;
           sleep(75)
           end;
       end
    else pion.Top:=y ;
    if cachecache then pion.Hide ;
    can_play:=true ;
    end
else result:=1 ;
end ;

function tform1.verif : string ;
var i, j, x, y : integer ;
    mot : string ;
begin
//vrifications horizontales
for j:=1 to 6 do
    begin
    mot:='' ;
    for i:=1 to 7 do
        begin
        mot:=mot+plateau[i,j] ;
        if pos('1111',mot)<>0 then
           begin
           result:='rouge;H/'+inttostr(i-4)+'.'+inttostr(j) ;
           break ;
           end;
        if pos('2222',mot)<>0 then
           begin
           result:='vert;H/'+inttostr(i-4)+'.'+inttostr(j) ;
           break ;
           end;
        end;
    end;

//vrifications verticales
for i:=1 to 7 do
    begin
    mot:='' ;
    for j:=1 to 6 do
        begin
        mot:=mot+plateau[i,j] ;
        if pos('1111',mot)<>0 then
           begin
           result:='rouge;V/'+inttostr(i)+'.'+inttostr(j-4) ;
           break ;
           end;
        if pos('2222',mot)<>0 then
           begin
           result:='vert;V/'+inttostr(i)+'.'+inttostr(j-4) ;
           break ;
           end;
        end;
    end;

//vrifications diagonales
//diagonales vers haut droite
x:=1 ;
y:=4 ;
mot:='' ;
for i:=1 to 30 do
    begin
    mot:=mot+plateau[x,y] ;
    x:=x+1 ;
    y:=y-1 ;
    if i=4 then
       begin
       x:=1 ;
       y:=5 ;
       mot:='' ;
       end ;
    if i=9 then
       begin
       x:=1 ;
       y:=6 ;
       mot:='' ;
       end ;
    if i=15 then
       begin
       x:=2 ;
       y:=6 ;
       mot:='' ;
       end;
    if i=21 then
       begin
       x:=3 ;
       y:=6 ;
       mot:='' ;
       end;
    if i=26 then
       begin
       x:=4 ;
       y:=6 ;
       mot:='' ;
       end;
    if pos('1111',mot)<>0 then
       begin
       result:='rouge;DD/'+inttostr(x)+'.'+inttostr(y) ;
       break ;
       end;
    if pos('2222',mot)<>0 then
       begin
       result:='vert;DD/'+inttostr(x)+'.'+inttostr(y) ;
       break ;
       end;
    end;
//diagonales haut vers gauche
x:=4 ;
y:=6 ;
mot:='' ;
for i:=1 to 30 do
    begin
    mot:=mot+plateau[x,y] ;
    x:=x-1 ;
    y:=y-1 ;
    if pos('1111',mot)<>0 then
       begin
       result:='rouge;DG/'+inttostr(x)+'.'+inttostr(y) ;
       break ;
       end;
    if pos('2222',mot)<>0 then
       begin
       result:='vert;DG/'+inttostr(x)+'.'+inttostr(y) ;
       break ;
       end;
    if i=4 then
       begin
       x:=5 ;
       y:=6 ;
       mot:='' ;
       end ;
    if i=9 then
       begin
       x:=6 ;
       y:=6 ;
       mot:='' ;
       end ;
    if i=15 then
       begin
       x:=7 ;
       y:=6 ;
       mot:='' ;
       end;
    if i=21 then
       begin
       x:=7 ;
       y:=5 ;
       mot:='' ;
       end;
    if i=26 then
       begin
       x:=7 ;
       y:=4 ;
       mot:='' ;
       end;
    end;
end;

procedure TForm1.img_plateauClick(Sender: TObject );
var clik : tpoint ;
    oui : integer ;
    gagne, nom_pion : string ;
    posi1, posi2,x,y,i : integer ;
    pion : timage ;
begin
if can_play then
    begin
    clik:=form1.P_plateau.ScreenToClient(mouse.CursorPos) ;
    clik.X:=clik.X div 75 +1;
    if jrouge then
       begin
       oui:=creer_pion('rouge',clik.X) ;
       if oui=1 then showmessage('Dsol ya plus de pion rouge !') ;
       if oui<>2 then
          begin
          lbl_joueur.Caption:='A '+edt_jvert.Text+' de jouer' ;
          lbl_joueur.Font.Color:=clGreen ;
          jrouge:=false ;
          img_plateau.OnMouseMove(nil,[],0,0) ;
          end;
       end
    else
        begin
        oui:=creer_pion('vert',clik.X) ;
        if oui=1 then showmessage('Dsol ya plus de pion vert !') ;
        if oui<>2 then
           begin
           lbl_joueur.Caption:='A '+edt_jrouge.Text+' de jouer' ;
           lbl_joueur.Font.Color:=clRed ;
           jrouge:=true ;
           img_plateau.OnMouseMove(nil,[],0,0) ;
           end;
        end;
    gagne:=verif;
    if (jetons_vert=0) and (jetons_rouge=0) then
       begin
       can_play:=false ;
       lbl_gagnant.Font.Color:=clblack ;
       lbl_gagnant.Caption:='Boouuhh Match Nul !!' ;
       end ;
    if pos('rouge',gagne)<>0 then
       begin
       lbl_gagnant.Caption:=edt_jrouge.Text+' gagne !' ;
       score_rouge:=score_rouge+1 ;
       lbl_score_rouge.Caption:='Score : '+inttostr(score_rouge) ;
       lbl_gagnant.Font.Color:=Clred ;
       rgagne:=true ;
       can_play:=false ;
       end ;
    if pos('vert',gagne)<>0 then
       begin
       lbl_gagnant.Caption:=edt_jvert.Text+' gagne !' ;
       lbl_gagnant.Font.Color:=Clgreen ;
       score_vert:=score_vert+1 ;
       lbl_score_vert.Caption:='Score : '+inttostr(score_vert) ;
       vgagne:=true ;
       can_play:=false ;
       end;
    if (pos('rouge',gagne)<>0) or (pos('vert',gagne)<>0) then
       begin
       if pos('rouge',gagne)<>0 then nom_pion:='ROUGE_GAGNE' ;
       if pos('vert',gagne)<>0 then nom_pion:='VERT_GAGNE' ;
       if (pos('H',gagne)<>0) or (pos('V',gagne)<>0) then
          begin
          posi1:=pos('/',gagne) ;
          posi2:=pos('.',gagne) ;
          for i:=0 to 3 do
              begin
              if pos('H',gagne)<>0 then
                 begin
                 x:=strtoint(gagne[posi1+1])+i ;
                 y:=strtoint(gagne[posi2+1])-1 ;
                 end
              else
                  begin
                  x:=strtoint(gagne[posi1+1])-1 ;
                  y:=strtoint(gagne[posi2+1])+i ;
                  end ;
              pion:=timage.Create(self);
              pion.Picture.Bitmap.LoadFromResourceName(hinstance,nom_pion);
              pion.Parent:=P_plateau ;
              pion.Left:=x*75 ;
              pion.Top:=y*75 ;
              pion.Show ;
              liste_pion.Add(pion) ;
              end
          end ;
       if (pos('DD',gagne)<>0) or (pos('DG',gagne)<>0) then
          begin
          posi1:=pos('/',gagne) ;
          posi2:=pos('.',gagne) ;
          if pos('DD',gagne)<>0 then
             begin
             x:=strtoint(gagne[posi1+1])-2 ;
             y:=strtoint(gagne[posi2+1]) ;
             end
          else
              begin
              x:=strtoint(gagne[posi1+1]) ;
              y:=strtoint(gagne[posi2+1]) ;
              end;
          for i:=0 to 3 do
              begin
              pion:=timage.Create(self);
              pion.Picture.Bitmap.LoadFromResourceName(hinstance,nom_pion);
              pion.Parent:=P_plateau ;
              pion.Left:=x*75 ;
              pion.Top:=y*75 ;
              pion.Show ;
              liste_pion.Add(pion) ;
              if pos('DD',gagne)<>0 then x:=x-1
              else x:=x+1 ;
              y:=y+1 ;
              end
          end
       end
    end
end;

procedure TForm1.FormCreate(Sender: TObject);
var i,j : integer ;
begin
randomize ;
doublebuffered:=true ; //vite les scintillements
for j:=1 to 6 do
    begin
    for i:=1 to 7 do
        begin
        plateau[i,j]:='0' ;
        end;
    end;
jetons_rouge:=21 ;
lbl_jetons_rouge.Caption:='21' ;
jetons_vert:=21 ;
lbl_jetons_vert.Caption:='21' ;
pion_expo:=timage.Create(self);
pion_expo.OnClick:=img_plateau.OnClick ;
pion_expo.Height:=67 ;
pion_expo.Parent:=P_expo ;
pion_expo.Transparent:=true ;
pion_expo.Top:=(P_expo.Height-pion_expo.Height) div 2 ;
pion_expo.OnMouseMove:=img_plateau.OnMouseMove ;
liste_pion:=tlist.Create ;
liste_pion.Clear ;
can_play:=false ;
lbl_gagnant.Caption:='' ;
score_rouge:=0 ;
score_vert:=0 ;
rgagne:=false ;
vgagne:=false ;
tps_rouge:=0 ;
tps_vert:=0 ;
cachecache:=false ;
anime_pion:=true ;
thread_titre.mot:='Puissance 4 - Jeannot Alpin - Dfi Delphi - Developpez.com' ;
titre:=TTitre.Create(false);
titre.FreeOnTerminate:=true ;
end;

procedure TForm1.Button1Click(Sender: TObject); //sert  afficher le contenue du tableau
var i,j : integer ;
    tab : string ;
begin
for j:=1 to 6 do
    begin
    tab:='' ;
    for i:=1 to 7 do
        begin
        tab:=tab+plateau[i,j]
        end;
    end;
end;

procedure TForm1.img_plateauMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var clik : tpoint ;
begin
if can_play then
    begin
    clik:=form1.Img_plateau.ScreenToClient(mouse.CursorPos) ;
    if jrouge then
       begin
       pion_expo.Picture.Bitmap.LoadFromResourceName(hinstance,'ROUGE_EXPO');
       pion_expo.Left:=(clik.X div 75)*75 ;
       end
    else
        begin
        pion_expo.Picture.Bitmap.LoadFromResourceName(hinstance,'VERT_EXPO');
        pion_expo.Left:=(clik.X div 75)*75 ;
        end;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var i : integer ;
    image : timage ;
begin
liste_pion.Pack ; //enlever tous les nil
for i:=0 to liste_pion.Count-1 do
    begin
    image:=liste_pion.items[i] ;
    image.Free ;
    end;
pion_expo.Free ;
liste_pion.Free ;
titre.Terminate ;
end;

procedure TForm1.btn_newPartiClick(Sender: TObject);
var i,j,alea : integer ;
    image : timage ;
begin
for j:=1 to 6 do
    begin
    for i:=1 to 7 do
        begin
        plateau[i,j]:='0' ;
        end;
    end;
alea:=random(2) ;
if alea=0 then
   begin
   jrouge:=true ;
   lbl_joueur.Caption:='A '+edt_jrouge.Text+' de jouer' ;
   lbl_joueur.Font.Color:=Clred ;
   end
else
    begin
    jrouge:=false ;
    lbl_joueur.Caption:='A '+edt_jvert.Text+' de jouer' ;
    lbl_joueur.Font.Color:=Clgreen ;
    end;
jetons_rouge:=21 ;
lbl_jetons_rouge.Caption:='21' ;
jetons_vert:=21 ;
lbl_jetons_vert.Caption:='21' ;
liste_pion.Pack ; //enlever tous les nil
for i:=0 to liste_pion.Count-1 do
    begin
    image:=liste_pion.items[i] ;
    image.Free ;
    end;
liste_pion.Clear ;
can_play:=true ;
lbl_gagnant.Caption:='' ;
rgagne:=false ;
vgagne:=false ;
img_plateau.OnMouseMove(nil,[],0,0) ;
tps_rouge:=0 ;
lbl_tps_rouge.Caption:='0' ;
tps_vert:=0 ;
lbl_tps_vert.Caption:='0'  ;
cachecache:=false ;
btn_cachecache.Caption:='Cacher les pions' ;
edt_jrouge.Enabled:=false ;
edt_jvert.Enabled:=false ;
lbl_directive.Hide ;
lbl_tips.Hide ;
end;

procedure TForm1.btn_enregistrerClick(Sender: TObject);
var chemin,tab : string ;
    texte : textfile ;
    i,j : integer ;
begin
//cration fichier texte de sauvegarde de la partie
//structure du fichier texte :
//les 6 premires lignes : place des pions (tableau plateau)
//puis le nom du joueur rouge
//puis le nom du joueur vert
//puis le joueur qui doit jouer
//puis le nombre de jetons rouges
//puis le nombre de jetons verts
//puis  le score rouge
//puis le score vert
//puis le temps de jeu rouge
//puis le temps de jeu vert
//puis 'rouge' ou 'vert' ou rien pour savoir si un joueur avait gagnait ou non la partie lors de la sauvegarde
try
    chemin:=extractfilepath(paramstr(0)) ; //rcupere le chemin du dossier o est l'exe
    assignfile(texte,chemin+'p4_save.p4s') ;
    rewrite(texte) ;
    for j:=1 to 6 do
        begin
        tab:='' ;
        for i:=1 to 7 do
            begin
            tab:=tab+plateau[i,j]
            end;
        writeln(texte,tab) ;
        end;
    writeln(texte,edt_jrouge.text) ;
    writeln(texte,edt_jvert.text) ;
    if jrouge then writeln(texte,'jrouge')
    else writeln(texte,'jvert') ;
    writeln(texte,inttostr(jetons_rouge)) ;
    writeln(texte,inttostr(jetons_vert)) ;
    writeln(texte,inttostr(score_rouge)) ;
    writeln(texte,inttostr(score_vert)) ;
    writeln(texte,inttostr(tps_rouge)) ;
    writeln(texte,inttostr(tps_vert)) ;
    if rgagne then writeln(texte,'rouge') ;
    if vgagne then writeln(texte,'vert') ;
    lbl_message.Caption:='Partie Sauvegarde !' ;
finally
       closefile(texte) ;
       end;
end;

procedure TForm1.btn_chargerClick(Sender: TObject);
var texte : textfile ;
    chemin, tab, pion_nom, joueur, pionr, pionv,scorer, scorev, gagne, tpsr, tpsv, nomr, nomv : string ;
    i,j : integer ;
    pion : timage ;
begin
try
    chemin:=extractfilepath(paramstr(0)) ;
    assignfile(texte,chemin+'p4_save.p4s') ;
    reset(texte) ;
    liste_pion.Pack ;
    for i:=0 to liste_pion.Count-1 do
        begin
        pion:=liste_pion.items[i] ;
        pion.Free ;
        end;
    liste_pion.Clear ;
    for j:=1 to 6 do
       begin
       readln(texte,tab) ;
       for i:=1 to 7 do
           begin
           plateau[i,j]:=tab[i] ;
           end;
       end;
    for i:=1 to 7 do
        begin
        for j:=1 to 6 do
            begin
            if plateau[i,j]<>'0' then
               begin
               pion:=timage.Create(self);
               if plateau[i,j]='1' then pion_nom:='ROUGE' ;
               if plateau[i,j]='2' then pion_nom:='VERT' ;
               pion.Picture.Bitmap.LoadFromResourceName(hinstance,pion_nom);
               pion.Parent:=p_plateau ;
               if not(cachecache) then pion.Show
               else pion.Hide ;
               pion.Left:=(i-1)*75 ;
               pion.Top:=(j-1)*75 ;
               liste_pion.Add(pion) ;
               end
            end;
        end;
    readln(texte,nomr) ;
    readln(texte,nomv) ;
    edt_jrouge.Text:=nomr ;
    edt_jvert.Text:=nomv ;
    edt_jrouge.Enabled:=false ;
    edt_jvert.Enabled:=false ;
    lbl_directive.Hide ;
    lbl_tips.Hide ;
    readln(texte,joueur) ;
    if joueur='jrouge' then
       begin
       jrouge:=true ;
       lbl_joueur.Caption:='A '+edt_jrouge.Text+' de jouer' ;
       lbl_joueur.Font.Color:=Clred ;
       end ;
    if joueur='jvert' then
       begin
       jrouge:=false ;
       lbl_joueur.Caption:='A '+edt_jvert.Text+' de jouer' ;
       lbl_joueur.Font.Color:=Clgreen ;
       end;
    readln(texte,pionr) ;
    readln(texte,pionv) ;
    jetons_rouge:=strtoint(pionr) ;
    lbl_jetons_rouge.Caption:=pionr ;
    jetons_vert:=strtoint(pionv) ;
    lbl_jetons_vert.Caption:=pionv ;
    readln(texte,scorer) ;
    readln(texte,scorev) ;
    score_rouge:=strtoint(scorer) ;
    score_vert:=strtoint(scorev) ;
    lbl_score_rouge.Caption:='Score : '+scorer ;
    lbl_score_vert.Caption:='Score : '+scorev ;
    readln(texte,tpsr) ;
    readln(texte,tpsv) ;
    tps_rouge:=strtoint(tpsr) ;
    tps_vert:=strtoint(tpsv) ;
    lbl_tps_rouge.Caption:=tpsr ;
    lbl_tps_vert.Caption:=tpsv ;
    readln(texte,gagne) ;
    if gagne='rouge' then
       begin
       lbl_gagnant.Caption:=edt_jrouge.Text+' gagne' ;
       lbl_gagnant.Font.Color:=clred ;
       can_play:=false ;
       end
    else if gagne='vert' then
       begin
       lbl_gagnant.Caption:=edt_jvert.Text+' gagne' ;
       lbl_gagnant.Font.Color:=clgreen ;
       can_play:=false ;
       end
    else if (jetons_rouge=0) and (jetons_vert=0) then
         begin
         lbl_gagnant.Caption:='Boouuhh Match Nul !!' ;
         lbl_gagnant.Font.Color:=clblack ;
         can_play:=false
         end
    else
        begin
        lbl_gagnant.Caption:='' ;
        can_play:=true ;
        end;
    lbl_message.Caption:='Partie charge !' ;
    img_plateau.OnMouseMove(nil,[],0,0) ;
    closefile(texte) ;
except
      showmessage('Dsol aucune sauvegarde n''existe !') ;
      exit ;
      end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if jrouge and can_play then
   begin
   tps_rouge:=tps_rouge+1 ;
   lbl_tps_rouge.Caption:=inttostr(tps_rouge) ;
   end
else if not(jrouge) and can_play then
    begin
    tps_vert:=tps_vert+1 ;
    lbl_tps_vert.Caption:=inttostr(tps_vert) ;
    end ;
end;

procedure TForm1.btn_cachecacheClick(Sender: TObject);
var i :integer ;
    pion : timage ;
begin
if not(cachecache) then
   begin
    cachecache:=true ;
    btn_cachecache.Caption:='Montrer les pions' ;
    liste_pion.Pack ;
    for i:=0 to liste_pion.Count-1 do
        begin
        pion:=liste_pion.items[i] ;
        pion.Hide ;
        end;
    end
else
    begin
    cachecache:=false ;
    btn_cachecache.Caption:='Cacher les pions' ;
    liste_pion.Pack ;
    for i:=0 to liste_pion.Count-1 do
        begin
        pion:=liste_pion.items[i] ;
        pion.Show ;
        end;
    end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);   //pour jouer avec le clavier
var point : tpoint ;
begin
case key of
     '1','2','3','4','5','6','7' : begin
         point.X:=strtoint(key)*75+P_plateau.Left+form1.Left-45 ;//place le curseur sur la bonne colonne
         point.Y:=mouse.CursorPos.Y ;
         setcursorpos(point.X,point.Y) ;
         img_plateau.OnClick(sender) ;  //et on appelle un clik sur l'image
         end;

     end;

end;

procedure TForm1.Check_titreClick(Sender: TObject);
begin
if check_titre.Checked then titre.Resume
else
    begin
    titre.Suspend ;
    form1.Caption:='Puissance 4 - Jeannot Alpin - Dfi Delphi - Developpez.com' ;
    end;
end;

procedure TForm1.check_pionClick(Sender: TObject);
begin
if check_pion.Checked then anime_pion:=true
else anime_pion:=false ;
end;

procedure TForm1.btn_reinitialisationClick(Sender: TObject);
begin
score_rouge:=0 ;
score_vert:=0 ;
lbl_score_rouge.Caption:='Score : 0' ;
lbl_score_vert.Caption:='Score : 0' ;
edt_jrouge.Enabled:=true ;
edt_jvert.Enabled:=true ;
can_play:=false ;
lbl_gagnant.Font.Color:=clblue ;
lbl_gagnant.caption:='Partie Interrompue !' ;
lbl_directive.Show ;
end;

end.
